use strict;
use warnings;
use Test::More tests => 13;

# $Id$

use_ok 'Vote', 'Vote';
use_ok 'Vote::DB';
$ENV{EPOLL_NO_COMMIT} = 1;
isa_ok(my $vote = Vote::DB->new(Vote->config->{db}), 'Vote::DB');

ok(my $pollid = $vote->create_poll('test@', "Vote test", "password"),
    "can create a new poll");

isa_ok(my $poll = $vote->poll($pollid), 'Vote::DB::Poll');

ok($poll->gen_poll_keys('keypass'), 'can generate poll keys');

$poll->addupd_voting($_) foreach (qw(a b c));

$poll->register_ballot('a', ['ch', 'ch2'], 'localhost');
$poll->register_ballot('b', ['ch'], 'localhost');
$poll->register_ballot('c', [], 'localhost');

isa_ok(my $results = $vote->results($pollid), 'Vote::DB::Poll');

ok($results->decrypted_ballots('keypass'), "Can decrypt ballot");

is($results->ballot_count_crypt, 3, "ballot count is 3");
is($results->ballot_count_clear, 3, "ballot count is 3");

ok(my $res = $results->results, "can get results");
is($res->[0]->{value}, 'ch', "winner is ch");
is($res->[0]->{count}, 2, "winner has two voices");

$vote->db->rollback; # really rollback
